

scoreboard players remove @a[scores={flag_cooldown=1..}] flag_cooldown 1
scoreboard players reset @a[scores={flag_cooldown=..0}] flag_cooldown

execute if score match_state game_state matches 1.. unless entity @a[team=crystal] as @e[type=armor_stand,tag=game_crystal] at @s run tag @a[team=pvp,distance=..1,sort=nearest,limit=1] add pickup_crystal
tag @a[scores={flag_cooldown=1..},tag=pickup_crystal] remove pickup_crystal

tag @a[tag=pickup_crystal,scores={flag_cooldown=1..}] remove pickup_crystal
clear @a[tag=pickup_crystal,team=pvp] leather_chestplate
execute if entity @a[tag=pickup_crystal,team=pvp] run title @a[team=!lobby] times 0 40 10
execute if entity @a[tag=pickup_crystal,team=pvp] run title @a[team=!lobby] title ""
execute if entity @a[tag=pickup_crystal,team=pvp] run stopsound @a neutral minecraft:block.portal.ambient
execute as @a[tag=pickup_crystal,team=pvp] run title @a[team=!lobby] subtitle {"selector":"@s","extra":[{"text":" picked up the ","color":"gray"},{"text":"Crystal","color":"light_purple"},{"text":"!","color":"gray"}]}
execute if entity @a[tag=pickup_crystal,team=pvp] as @a[team=!lobby] at @s run playsound minecraft:entity.illusioner.prepare_mirror master @s ~ ~1 ~ 0.8 1.5
execute if entity @a[tag=pickup_crystal,team=pvp] as @a[team=!lobby] at @s run playsound minecraft:entity.generic.explode master @s ~ ~1 ~ 0.25 1.8
effect give @a[tag=pickup_crystal,team=pvp] speed 2 2
team join crystal @a[tag=pickup_crystal,team=pvp]
tag @a[tag=pickup_crystal] remove pickup_crystal

execute as @e[type=armor_stand,tag=game_crystal,limit=1] at @s unless entity @e[type=end_crystal,distance=..0.1] run kill @e[type=end_crystal]

execute if score match_state game_state matches 1.. if entity @a[scores={death=1..},team=crystal] run title @a[team=!lobby] times 0 40 10
execute if score match_state game_state matches 1.. if entity @a[scores={death=1..},team=crystal] run title @a[team=!lobby] title ""
execute if score match_state game_state matches 1.. if entity @a[scores={death=1..},team=crystal] run title @a[team=!lobby] subtitle {"text":"The ","color":"gray","extra":[{"text":"Crystal","color":"light_purple"},{"text":" was dropped!"}]}
execute if score match_state game_state matches 1.. if entity @a[scores={death=1..},team=crystal] as @a[team=!lobby] at @s run playsound minecraft:entity.evoker.cast_spell player @s ~ ~1 ~ 0.5 1.5
execute if score match_state game_state matches 1.. if entity @a[scores={death=1..},team=crystal] as @a[team=!lobby] at @s run playsound minecraft:entity.generic.explode master @s ~ ~1 ~ 0.25 2

scoreboard players set @a[scores={death=1..},team=crystal] flag_cooldown 20
team join pvp @a[scores={death=1..},team=crystal]

execute if entity @a[team=crystal] run kill @e[type=armor_stand,tag=game_crystal]
execute if entity @a[team=crystal] run kill @e[type=end_crystal]

execute unless entity @e[type=end_crystal] as @e[type=armor_stand,tag=game_crystal,limit=1] at @s run summon end_crystal ~ ~-0.1 ~ {Invulnerable:1,Silent:1,Glowing:1,ShowBottom:0b,Tags:["game_crystal"]}
team join crystal @e[type=end_crystal]
execute as @e[type=armor_stand,tag=game_crystal] at @s run particle instant_effect ~ ~0.5 ~ 0.4 0.4 0.4 0 1
execute as @e[type=armor_stand,tag=game_crystal,nbt={Marker:1b}] run data merge entity @s {Marker:0}
execute as @a[team=crystal] at @s run summon armor_stand ~ ~ ~ {Tags:["game_crystal"],Invisible:1,Invulnerable:1,Small:1,DisabledSlots:4144896,NoBasePlate:1,Silent:1,PersistenceRequired:1,Marker:1b}

clear @a[team=crystal,nbt=!{Inventory:[{Slot:7b,id:"minecraft:end_crystal",tag:{Crystal:1b}}]}] end_crystal{Crystal:1b}
item replace entity @a[team=crystal,nbt=!{Inventory:[{Slot:7b,id:"minecraft:end_crystal",tag:{Crystal:1b}}]}] hotbar.7 with end_crystal{Crystal:1b,display:{Name:'{"text":"End Crystal","color":"light_purple","italic":"false"}'}}
clear @a[team=!crystal,nbt=!{Inventory:[{tag:{Crystal:1b}}]}] end_crystal{Crystal:1b}



effect give @a[team=crystal] glowing infinite 0 true
effect clear @a[team=!crystal] glowing

scoreboard players remove @e[type=end_crystal] sound_timer 1
execute as @e[type=end_crystal,scores={sound_timer=39}] at @s run playsound minecraft:block.portal.ambient neutral @a ~ ~1 ~ 0.4 1.8
scoreboard players set @e[type=end_crystal,scores={sound_timer=..0}] sound_timer 40

execute if score match_state game_state matches 1.. run scoreboard players add @a[team=crystal] points 1
execute if score match_state game_state matches 1.. as @a[team=crystal] run scoreboard players operation @s sound_timer = @s points
execute if score match_state game_state matches 1.. as @a[team=crystal] run scoreboard players operation @s sound_timer %= ticks_per_second constants
execute if score match_state game_state matches 1.. as @a[team=crystal,scores={sound_timer=0}] at @s run playsound minecraft:entity.experience_orb.pickup player @s ~ ~1 ~ 0.1 1.6

execute as @a[team=crystal] if score @s points_modified > leading_score game_state run tag @a[tag=leading] remove leading
execute as @a[team=crystal] if score @s points_modified > leading_score game_state run tag @s add leading
execute as @a[team=crystal] if score @s points_modified > leading_score game_state run scoreboard players operation leading_score game_state = @s points_modified

execute as @a[team=crystal] if score @s points_modified >= score_target game_state run tag @s add determine_winner
tag @a[sort=random,limit=1,tag=determine_winner] add winner
tag @a[tag=determine_winner] remove determine_winner
